      subroutine filt

c     read in filter functions for the images

      implicit none

      include 'filt.txt'

      integer i,nf,ifilt
      character junk*5,filnam*20
      real*8 rjunk,fact,w,f,fint,w_ave

      fact=2.9979e14
c     fact=1.2398

      data filtnames /'2J.txt','2H.txt','2K.txt','I1.txt','I2.txt'
     $ ,'I3.txt','I4.txt','M1.txt','M2.txt','M3.txt','S1.txt','S2.txt'
     $ ,'S3.txt','S4.txt','XA.txt','XC.txt','XD.txt','XE.txt'
     $ ,'Z1.txt','Z2.txt'/

      data nwfilt /108,59,76,506,428,371,422,129,112,401
     $  ,19,33,22,17,632,319,403,1097,4,4/

c     nfilt is number of filter files
      do ifilt=1,nfilt
         fint=0.d0
         filnam='../parfiles/'//filtnames(ifilt)
         print*,filnam
c        nf=number of lines in this filter file. subtract 1 for the header
         nf=nwfilt(ifilt)-1
         open(unit=14,file=filnam,status='unknown')
         read(14,*) junk
	 do i=1,nf
            read(14,*) w,f 
c     convert wavelength to frequency
            filtwave(i,ifilt)=fact/w
            filtphi(i,ifilt)=f
         enddo
         close(14)
c     integrate filter to determine normalization factor
c     tom says they are already normalized but let's check
         fint=0.d0
         w_ave=0.d0
         do i=1,nf-1
            fint=0.5*(filtphi(i+1,ifilt)+filtphi(i,ifilt))*
     $        (filtwave(i+1,ifilt)-filtwave(i,ifilt))+fint
            w_ave=w_ave+(filtwave(i+1,ifilt)-filtwave(i,ifilt))*
     $         0.5*(filtphi(i+1,ifilt)+filtphi(i,ifilt))*
     $         0.5*(filtwave(i+1,ifilt)+filtwave(i,ifilt))
         enddo
         w_ave=w_ave/fint
         print*,'wave average, width',
     $      fact/w_ave,fact/filtwave(1,ifilt)-fact/filtwave(nf,ifilt)
         print*,'norm factor',fint
c     rescale filter
         do i=1,nf
            filtphi(i,ifilt)=filtphi(i,ifilt)/fint
         enddo
      enddo

      end

